Index: squid/src/auth/ntlm/helpers/SMB/smbval/smblib.c
diff -u /dev/null squid/src/auth/ntlm/helpers/SMB/smbval/smblib.c:1.2.10.1
--- /dev/null	Mon Jan 26 04:57:41 2004
+++ squid/src/auth/ntlm/helpers/SMB/smbval/smblib.c	Tue Sep  3 10:42:42 2002
@@ -0,0 +1,575 @@
+
+/* UNIX SMBlib NetBIOS implementation
+ * 
+ * Version 1.0
+ * SMBlib Routines
+ * 
+ * Copyright (C) Richard Sharpe 1996
+ * 
+ */
+
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+
+#include "config.h"
+#include <malloc.h>
+#include <ctype.h>
+#include <string.h>
+
+int SMBlib_errno;
+int SMBlib_SMB_Error;
+#define SMBLIB_ERRNO
+#define uchar unsigned char
+#include "smblib-priv.h"
+
+#include "rfcnb.h"
+#include "smbencrypt.h"
+
+#include <signal.h>
+
+/* #define DEBUG */
+
+SMB_State_Types SMBlib_State;
+
+/* Initialize the SMBlib package     */
+
+int
+SMB_Init()
+{
+
+    SMBlib_State = SMB_State_Started;
+
+    signal(SIGPIPE, SIG_IGN);	/* Ignore these ... */
+
+/* If SMBLIB_Instrument is defines, turn on the instrumentation stuff */
+#ifdef SMBLIB_INSTRUMENT
+
+    SMBlib_Instrument_Init();
+
+#endif
+
+    return 0;
+
+}
+
+int
+SMB_Term()
+{
+
+#ifdef SMBLIB_INSTRUMENT
+
+    SMBlib_Instrument_Term();	/* Clean up and print results */
+
+#endif
+
+    return 0;
+
+}
+
+/* SMB_Create: Create a connection structure and return for later use */
+/* We have other helper routines to set variables                     */
+
+SMB_Handle_Type
+SMB_Create_Con_Handle()
+{
+
+    SMBlib_errno = SMBlibE_NotImpl;
+    return (NULL);
+
+}
+
+int
+SMBlib_Set_Sock_NoDelay(SMB_Handle_Type Con_Handle, BOOL yn)
+{
+
+
+    if (RFCNB_Set_Sock_NoDelay(Con_Handle->Trans_Connect, yn) < 0) {
+
+#ifdef DEBUG
+#endif
+
+	fprintf(stderr, "Setting no-delay on TCP socket failed ...\n");
+
+    }
+    return (0);
+
+}
+
+/* SMB_Connect_Server: Connect to a server, but don't negotiate protocol */
+/* or anything else ...                                                  */
+
+SMB_Handle_Type
+SMB_Connect_Server(SMB_Handle_Type Con_Handle,
+    char *server, char *NTdomain)
+{
+    SMB_Handle_Type con;
+    char called[80], calling[80], *address;
+    int i;
+
+    /* Get a connection structure if one does not exist */
+
+    con = Con_Handle;
+
+    if (Con_Handle == NULL) {
+
+	if ((con = (struct SMB_Connect_Def *) malloc(sizeof(struct SMB_Connect_Def))) == NULL) {
+
+
+	    SMBlib_errno = SMBlibE_NoSpace;
+	    return NULL;
+	}
+    }
+    /* Init some things ... */
+
+    strcpy(con->service, "");
+    strcpy(con->username, "");
+    strcpy(con->password, "");
+    strcpy(con->sock_options, "");
+    strcpy(con->address, "");
+    strcpy(con->desthost, server);
+    strcpy(con->PDomain, NTdomain);
+    strcpy(con->OSName, SMBLIB_DEFAULT_OSNAME);
+    strcpy(con->LMType, SMBLIB_DEFAULT_LMTYPE);
+    con->first_tree = con->last_tree = NULL;
+
+    /* ugh. This is horribly broken. */
+/*   SMB_Get_My_Name(con -> myname, sizeof(con -> myname)); */
+    /* hacked by Kinkie */
+    i = gethostname(con->myname, sizeof(con->myname));
+    if (i == -1) {
+	strcpy(con->myname, "unknown");
+    } else {
+	if (NULL != (address = strchr(con->myname, '.'))) {
+	    *address = '\0';	/* truncate at first '.' */
+	}
+    }
+
+
+    con->port = 0;		/* No port selected */
+
+    /* Get some things we need for the SMB Header */
+
+    con->pid = getpid();
+    con->mid = con->pid;	/* This will do for now ... */
+    con->uid = 0;		/* Until we have done a logon, no uid ... */
+    con->gid = getgid();
+
+    /* Now connect to the remote end, but first upper case the name of the
+     * service we are going to call, sine some servers want it in uppercase */
+
+    for (i = 0; i < strlen(server); i++)
+	called[i] = toupper(server[i]);
+
+    called[strlen(server)] = 0;	/* Make it a string */
+
+    for (i = 0; i < strlen(con->myname); i++)
+	calling[i] = toupper(con->myname[i]);
+
+    calling[strlen(con->myname)] = 0;	/* Make it a string */
+
+    if (strcmp(con->address, "") == 0)
+	address = con->desthost;
+    else
+	address = con->address;
+
+    con->Trans_Connect = RFCNB_Call(called,
+	calling,
+	address,		/* Protocol specific */
+	con->port);
+
+    /* Did we get one? */
+
+    if (con->Trans_Connect == NULL) {
+
+	if (Con_Handle == NULL) {
+	    Con_Handle = NULL;
+	    free(con);
+	}
+	SMBlib_errno = -SMBlibE_CallFailed;
+	return NULL;
+
+    }
+    return (con);
+
+}
+
+/* SMB_Connect: Connect to the indicated server                       */
+/* If Con_Handle == NULL then create a handle and connect, otherwise  */
+/* use the handle passed                                              */
+
+char *SMB_Prots_Restrict[] =
+{"PC NETWORK PROGRAM 1.0",
+    NULL};
+
+
+SMB_Handle_Type
+SMB_Connect(SMB_Handle_Type Con_Handle,
+    SMB_Tree_Handle * tree,
+    char *service,
+    char *username,
+    char *password)
+{
+    SMB_Handle_Type con;
+    char *host, *address;
+    char temp[80], called[80], calling[80];
+    int i;
+
+    /* Get a connection structure if one does not exist */
+
+    con = Con_Handle;
+
+    if (Con_Handle == NULL) {
+
+	if ((con = (struct SMB_Connect_Def *) malloc(sizeof(struct SMB_Connect_Def))) == NULL) {
+
+	    SMBlib_errno = SMBlibE_NoSpace;
+	    return NULL;
+	}
+    }
+    /* Init some things ... */
+
+    strcpy(con->service, service);
+    strcpy(con->username, username);
+    strcpy(con->password, password);
+    strcpy(con->sock_options, "");
+    strcpy(con->address, "");
+    strcpy(con->PDomain, SMBLIB_DEFAULT_DOMAIN);
+    strcpy(con->OSName, SMBLIB_DEFAULT_OSNAME);
+    strcpy(con->LMType, SMBLIB_DEFAULT_LMTYPE);
+    con->first_tree = con->last_tree = NULL;
+
+    SMB_Get_My_Name(con->myname, sizeof(con->myname));
+
+    con->port = 0;		/* No port selected */
+
+    /* Get some things we need for the SMB Header */
+
+    con->pid = getpid();
+    con->mid = con->pid;	/* This will do for now ... */
+    con->uid = 0;		/* Until we have done a logon, no uid */
+    con->gid = getgid();
+
+    /* Now figure out the host portion of the service */
+
+    strcpy(temp, service);
+    host = (char *) strtok(temp, "/\\");	/* Separate host name portion */
+    strcpy(con->desthost, host);
+
+    /* Now connect to the remote end, but first upper case the name of the
+     * service we are going to call, sine some servers want it in uppercase */
+
+    for (i = 0; i < strlen(host); i++)
+	called[i] = toupper(host[i]);
+
+    called[strlen(host)] = 0;	/* Make it a string */
+
+    for (i = 0; i < strlen(con->myname); i++)
+	calling[i] = toupper(con->myname[i]);
+
+    calling[strlen(con->myname)] = 0;	/* Make it a string */
+
+    if (strcmp(con->address, "") == 0)
+	address = con->desthost;
+    else
+	address = con->address;
+
+    con->Trans_Connect = RFCNB_Call(called,
+	calling,
+	address,		/* Protocol specific */
+	con->port);
+
+    /* Did we get one? */
+
+    if (con->Trans_Connect == NULL) {
+
+	if (Con_Handle == NULL) {
+	    free(con);
+	    Con_Handle = NULL;
+	}
+	SMBlib_errno = -SMBlibE_CallFailed;
+	return NULL;
+
+    }
+    /* Now, negotiate the protocol */
+
+    if (SMB_Negotiate(con, SMB_Prots_Restrict) < 0) {
+
+	/* Hmmm what should we do here ... We have a connection, but could not
+	 * negotiate ...                                                      */
+
+	return NULL;
+
+    }
+    /* Now connect to the service ... */
+
+    if ((*tree = SMB_TreeConnect(con, NULL, service, password, "A:")) == NULL) {
+
+	return NULL;
+
+    }
+    return (con);
+
+}
+
+/* Logon to the server. That is, do a session setup if we can. We do not do */
+/* Unicode yet!                                                             */
+
+int
+SMB_Logon_Server(SMB_Handle_Type Con_Handle, char *UserName,
+    char *PassWord, char *UserDomain, int precrypted)
+{
+    struct RFCNB_Pkt *pkt;
+    int param_len, pkt_len, pass_len;
+    char *p, pword[128];
+
+    /* First we need a packet etc ... but we need to know what protocol has  */
+    /* been negotiated to figure out if we can do it and what SMB format to  */
+    /* use ...                                                               */
+
+    if (Con_Handle->protocol < SMB_P_LanMan1) {
+
+	SMBlib_errno = SMBlibE_ProtLow;
+	return (SMBlibE_BAD);
+
+    }
+    if (precrypted) {
+	pass_len = 24;
+	memcpy(pword, PassWord, 24);
+    } else {
+	strcpy(pword, PassWord);
+	if (Con_Handle->encrypt_passwords) {
+	    pass_len = 24;
+	    SMBencrypt((uchar *) PassWord, (uchar *) Con_Handle->Encrypt_Key, (uchar *) pword);
+	} else
+	    pass_len = strlen(pword);
+    }
+
+    /* Now build the correct structure */
+
+    if (Con_Handle->protocol < SMB_P_NT1) {
+
+	param_len = strlen(UserName) + 1 + pass_len + 1 +
+	    strlen(UserDomain) + 1 +
+	    strlen(Con_Handle->OSName) + 1;
+
+	pkt_len = SMB_ssetpLM_len + param_len;
+
+	pkt = (struct RFCNB_Pkt *) RFCNB_Alloc_Pkt(pkt_len);
+
+	if (pkt == NULL) {
+
+	    SMBlib_errno = SMBlibE_NoSpace;
+	    fprintf(stderr, "SMB_Logon_server: Couldn't allocate packet\n");
+	    return (SMBlibE_BAD);	/* Should handle the error */
+	}
+	bzero(SMB_Hdr(pkt), SMB_ssetpLM_len);
+	SIVAL(SMB_Hdr(pkt), SMB_hdr_idf_offset, SMB_DEF_IDF);	/* Plunk in IDF */
+	*(SMB_Hdr(pkt) + SMB_hdr_com_offset) = SMBsesssetupX;
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_pid_offset, Con_Handle->pid);
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_tid_offset, 0);
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_mid_offset, Con_Handle->mid);
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_uid_offset, Con_Handle->uid);
+	*(SMB_Hdr(pkt) + SMB_hdr_wct_offset) = 10;
+	*(SMB_Hdr(pkt) + SMB_hdr_axc_offset) = 0xFF;	/* No extra command */
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_axo_offset, 0);
+
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpLM_mbs_offset, SMBLIB_MAX_XMIT);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpLM_mmc_offset, 2);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpLM_vcn_offset, Con_Handle->pid);
+	SIVAL(SMB_Hdr(pkt), SMB_ssetpLM_snk_offset, 0);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpLM_pwl_offset, pass_len + 1);
+	SIVAL(SMB_Hdr(pkt), SMB_ssetpLM_res_offset, 0);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpLM_bcc_offset, param_len);
+
+	/* Now copy the param strings in with the right stuff */
+
+	p = (char *) (SMB_Hdr(pkt) + SMB_ssetpLM_buf_offset);
+
+	/* Copy  in password, then the rest. Password has a null at end */
+
+	memcpy(p, pword, pass_len);
+
+	p = p + pass_len + 1;
+
+	strcpy(p, UserName);
+	p = p + strlen(UserName);
+	*p = 0;
+
+	p = p + 1;
+
+	strcpy(p, UserDomain);
+	p = p + strlen(UserDomain);
+	*p = 0;
+	p = p + 1;
+
+	strcpy(p, Con_Handle->OSName);
+	p = p + strlen(Con_Handle->OSName);
+	*p = 0;
+
+    } else {
+
+	/* We don't admit to UNICODE support ... */
+
+	param_len = strlen(UserName) + 1 + pass_len +
+	    strlen(UserDomain) + 1 +
+	    strlen(Con_Handle->OSName) + 1 +
+	    strlen(Con_Handle->LMType) + 1;
+
+	pkt_len = SMB_ssetpNTLM_len + param_len;
+
+	pkt = (struct RFCNB_Pkt *) RFCNB_Alloc_Pkt(pkt_len);
+
+	if (pkt == NULL) {
+
+	    SMBlib_errno = SMBlibE_NoSpace;
+	    fprintf(stderr, "SMB_Logon_server: Couldn't allocate packet\n");
+	    return (-1);	/* Should handle the error */
+	}
+	bzero(SMB_Hdr(pkt), SMB_ssetpNTLM_len);
+	SIVAL(SMB_Hdr(pkt), SMB_hdr_idf_offset, SMB_DEF_IDF);	/* Plunk in IDF */
+	*(SMB_Hdr(pkt) + SMB_hdr_com_offset) = SMBsesssetupX;
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_pid_offset, Con_Handle->pid);
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_tid_offset, 0);
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_mid_offset, Con_Handle->mid);
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_uid_offset, Con_Handle->uid);
+	*(SMB_Hdr(pkt) + SMB_hdr_wct_offset) = 13;
+	*(SMB_Hdr(pkt) + SMB_hdr_axc_offset) = 0xFF;	/* No extra command */
+	SSVAL(SMB_Hdr(pkt), SMB_hdr_axo_offset, 0);
+
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_mbs_offset, SMBLIB_MAX_XMIT);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_mmc_offset, 0);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_vcn_offset, 1); /* Thanks Tridge! */
+	SIVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_snk_offset, 0);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_cipl_offset, pass_len);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_cspl_offset, 0);
+	SIVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_res_offset, 0);
+	SIVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_cap_offset, 0);
+	SSVAL(SMB_Hdr(pkt), SMB_ssetpNTLM_bcc_offset, param_len);
+
+	/* Now copy the param strings in with the right stuff */
+
+	p = (char *) (SMB_Hdr(pkt) + SMB_ssetpNTLM_buf_offset);
+
+	/* Copy  in password, then the rest. Password has no null at end */
+
+	memcpy(p, pword, pass_len);
+
+	p = p + pass_len;
+
+	strcpy(p, UserName);
+	p = p + strlen(UserName);
+	*p = 0;
+
+	p = p + 1;
+
+	strcpy(p, UserDomain);
+	p = p + strlen(UserDomain);
+	*p = 0;
+	p = p + 1;
+
+	strcpy(p, Con_Handle->OSName);
+	p = p + strlen(Con_Handle->OSName);
+	*p = 0;
+	p = p + 1;
+
+	strcpy(p, Con_Handle->LMType);
+	p = p + strlen(Con_Handle->LMType);
+	*p = 0;
+
+    }
+
+    /* Now send it and get a response */
+
+    if (RFCNB_Send(Con_Handle->Trans_Connect, pkt, pkt_len) < 0) {
+
+#ifdef DEBUG
+	fprintf(stderr, "Error sending SessSetupX request\n");
+#endif
+
+	RFCNB_Free_Pkt(pkt);
+	SMBlib_errno = SMBlibE_SendFailed;
+	return (SMBlibE_BAD);
+
+    }
+    /* Now get the response ... */
+
+    if (RFCNB_Recv(Con_Handle->Trans_Connect, pkt, pkt_len) < 0) {
+
+#ifdef DEBUG
+	fprintf(stderr, "Error receiving response to SessSetupAndX\n");
+#endif
+
+	RFCNB_Free_Pkt(pkt);
+	SMBlib_errno = SMBlibE_RecvFailed;
+	return (SMBlibE_BAD);
+
+    }
+    /* Check out the response type ... */
+
+    if (CVAL(SMB_Hdr(pkt), SMB_hdr_rcls_offset) != SMBC_SUCCESS) {	/* Process error */
+
+#ifdef DEBUG
+	fprintf(stderr, "SMB_SessSetupAndX failed with errorclass = %i, Error Code = %i\n",
+	    CVAL(SMB_Hdr(pkt), SMB_hdr_rcls_offset),
+	    SVAL(SMB_Hdr(pkt), SMB_hdr_err_offset));
+#endif
+
+	SMBlib_SMB_Error = IVAL(SMB_Hdr(pkt), SMB_hdr_rcls_offset);
+	RFCNB_Free_Pkt(pkt);
+	SMBlib_errno = SMBlibE_Remote;
+	return (SMBlibE_BAD);
+
+    }
+/** @@@ mdz: check for guest login { **/
+    if (SVAL(SMB_Hdr(pkt), SMB_ssetpr_act_offset) & 0x1) {
+	/* do we allow guest login? NO! */
+	return (SMBlibE_BAD);
+
+    }
+/** @@@ mdz: } **/
+
+
+#ifdef DEBUG
+    fprintf(stderr, "SessSetupAndX response. Action = %i\n",
+	SVAL(SMB_Hdr(pkt), SMB_ssetpr_act_offset));
+#endif
+
+    /* Now pick up the UID for future reference ... */
+
+    Con_Handle->uid = SVAL(SMB_Hdr(pkt), SMB_hdr_uid_offset);
+    RFCNB_Free_Pkt(pkt);
+
+    return (0);
+
+}
+
+
+/* Disconnect from the server, and disconnect all tree connects */
+
+int
+SMB_Discon(SMB_Handle_Type Con_Handle, BOOL KeepHandle)
+{
+
+    /* We just disconnect the connection for now ... */
+    if (Con_Handle != NULL)
+	RFCNB_Hangup(Con_Handle->Trans_Connect);
+
+    if (!KeepHandle)
+	free(Con_Handle);
+
+    return (0);
+
+}
Index: squid/src/auth/ntlm/helpers/SMB/smbval/smblib.h
diff -u /dev/null squid/src/auth/ntlm/helpers/SMB/smbval/smblib.h:1.2.10.1
--- /dev/null	Mon Jan 26 04:57:41 2004
+++ squid/src/auth/ntlm/helpers/SMB/smbval/smblib.h	Tue Sep  3 10:42:42 2002
@@ -0,0 +1,98 @@
+/* UNIX SMBlib NetBIOS implementation
+ * 
+ * Version 1.0
+ * SMBlib Defines
+ * 
+ * Copyright (C) Richard Sharpe 1996
+ * 
+ */
+
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+
+#include "std-defines.h"
+#include "smblib-common.h"
+
+/* Just define all the entry points */
+
+/* Create a handle to allow us to set/override some parameters ...       */
+
+void *SMB_Create_Con_Handle();
+
+/* Connect to a server, but do not do a tree con etc ... */
+
+void *SMB_Connect_Server(void *Con, char *server, char *NTdomain);
+
+/* Connect to a server and give us back a handle. If Con == NULL, create */
+/* The handle and populate it with defaults                              */
+
+void *SMB_Connect(void *Con, void **tree,
+    char *name, char *User, char *Password);
+
+/* Negotiate a protocol                                                  */
+
+int SMB_Negotiate(void *Con_Handle, char *Prots[]);
+
+/* Connect to a tree ...                                                 */
+
+void *SMB_TreeConnect(void *con_handle, void *tree_handle,
+    char *path, char *password, char *dev);
+
+/* Disconnect a tree ...                                                 */
+
+int SMB_TreeDisconect(void *tree_handle);
+
+/* Open a file                                                           */
+
+void *SMB_Open(void *tree_handle,
+    void *file_handle,
+    char *file_name,
+    unsigned short mode,
+    unsigned short search);
+
+/* Close a file                                                          */
+
+int SMB_Close(void *file_handle);
+
+/* Disconnect from server. Has flag to specify whether or not we keep the */
+/* handle.                                                                */
+
+int SMB_Discon(void *Con, BOOL KeepHandle);
+
+void *SMB_Create(void *Tree_Handle,
+    void *File_Handle,
+    char *file_name,
+    short search);
+
+int SMB_Delete(void *tree, char *file_name, short search);
+
+int SMB_Create_Dir(void *tree, char *dir_name);
+
+int SMB_Delete_Dir(void *tree, char *dir_name);
+
+int SMB_Check_Dir(void *tree, char *dir_name);
+
+int SMB_Get_Last_Error();
+
+int SMB_Get_Last_SMB_Err();
+
+int SMB_Get_Error_Msg(int msg, char *msgbuf, int len);
+
+void *SMB_Logon_And_TCon(void *con, void *tree, char *user, char *pass,
+    char *service, char *st);
+
+
+#define SMBLIB_DEFAULT_DOMAIN "anydom"
Index: squid/src/auth/ntlm/helpers/SMB/smbval/std-defines.h
diff -u /dev/null squid/src/auth/ntlm/helpers/SMB/smbval/std-defines.h:1.2.10.1
--- /dev/null	Mon Jan 26 04:57:41 2004
+++ squid/src/auth/ntlm/helpers/SMB/smbval/std-defines.h	Tue Sep  3 10:42:42 2002
@@ -0,0 +1,49 @@
+#ifndef __STD_DEFINES__
+#define __STD_DEFINES__
+
+/* RFCNB Standard includes ... */
+/*
+ * 
+ * SMBlib Standard Includes
+ * 
+ * Copyright (C) 1996, Richard Sharpe
+ * 
+ * One day we will conditionalize these on OS types ... */
+
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+
+#include "squid_types.h"
+#define BOOL int16_t
+#define int16 int16_t
+#define uint16 u_int16_t
+#define int32 int32_t
+#define uint32 u_int32_t
+
+#include <netdb.h>
+#include <sys/types.h>
+#include <netinet/in.h>
+#include <sys/socket.h>
+#include <signal.h>
+#include <errno.h>
+#include <stdio.h>
+#include <unistd.h>
+#include <strings.h>
+
+#define TRUE 1
+#define FALSE 0
+
+#endif /* __STD_DEFINES__ */
Index: squid/src/auth/ntlm/helpers/SMB/smbval/std-includes.h
diff -u /dev/null squid/src/auth/ntlm/helpers/SMB/smbval/std-includes.h:1.2.10.1
--- /dev/null	Mon Jan 26 04:57:41 2004
+++ squid/src/auth/ntlm/helpers/SMB/smbval/std-includes.h	Tue Sep  3 10:42:42 2002
@@ -0,0 +1,47 @@
+/* RFCNB Standard includes ... */
+/*
+ * 
+ * RFCNB Standard Includes
+ * 
+ * Copyright (C) 1996, Richard Sharpe
+ * 
+ * One day we will conditionalize these on OS types ... */
+
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+
+/* the types are provided by squid's configure preocess */
+#include "squid_types.h"
+#define BOOL int16_t
+#define int16 int16_t
+
+#include <netdb.h>
+#include <sys/types.h>
+#include <netinet/in.h>
+#include <sys/socket.h>
+#include <signal.h>
+#include <errno.h>
+#include <stdio.h>
+#include <unistd.h>
+
+#define TRUE 1
+#define FALSE 0
+
+/* Pick up define for INADDR_NONE */
+
+#ifndef INADDR_NONE
+#define INADDR_NONE -1
+#endif
Index: squid/src/auth/ntlm/helpers/SMB/smbval/valid.c
diff -u /dev/null squid/src/auth/ntlm/helpers/SMB/smbval/valid.c:1.2.10.1
--- /dev/null	Mon Jan 26 04:57:41 2004
+++ squid/src/auth/ntlm/helpers/SMB/smbval/valid.c	Tue Sep  3 10:42:42 2002
@@ -0,0 +1,106 @@
+#include <sys/types.h>
+#include <unistd.h>
+#include <syslog.h>
+#include <string.h>
+#include "smblib-priv.h"
+#include "valid.h"
+
+SMB_Handle_Type SMB_Connect_Server(void *, char *, char *);
+
+int
+Valid_User(char *USERNAME, char *PASSWORD, char *SERVER, char *BACKUP, char *DOMAIN)
+{
+    int pass_is_precrypted_p = 0;
+    char *SMB_Prots[] =
+    {
+/*              "PC NETWORK PROGRAM 1.0", */
+/*              "MICROSOFT NETWORKS 1.03", */
+/*              "MICROSOFT NETWORKS 3.0", */
+	"LANMAN1.0",
+	"LM1.2X002",
+	"Samba",
+/*              "NT LM 0.12", */
+/*              "NT LANMAN 1.0", */
+	NULL};
+    SMB_Handle_Type con;
+
+    SMB_Init();
+    con = SMB_Connect_Server(NULL, SERVER, DOMAIN);
+    if (con == NULL) {		/* Error ... */
+	con = SMB_Connect_Server(NULL, BACKUP, DOMAIN);
+	if (con == NULL) {
+	    return (NTV_SERVER_ERROR);
+	}
+    }
+    if (SMB_Negotiate(con, SMB_Prots) < 0) {	/* An error */
+	SMB_Discon(con, 0);
+	return (NTV_PROTOCOL_ERROR);
+    }
+    /* Test for a server in share level mode do not authenticate against it */
+    if (con->Security == 0) {
+	SMB_Discon(con, 0);
+	return (NTV_PROTOCOL_ERROR);
+    }
+    if (SMB_Logon_Server(con, USERNAME, PASSWORD, DOMAIN, pass_is_precrypted_p) < 0) {
+	SMB_Discon(con, 0);
+	return (NTV_LOGON_ERROR);
+    }
+    SMB_Discon(con, 0);
+    return (NTV_NO_ERROR);
+}
+
+void *
+NTLM_Connect(char *SERVER, char *BACKUP, char *DOMAIN, char *nonce)
+{
+    char *SMB_Prots[] =
+    {
+/*              "PC NETWORK PROGRAM 1.0", */
+/*              "MICROSOFT NETWORKS 1.03", */
+/*              "MICROSOFT NETWORKS 3.0", */
+	"LANMAN1.0",
+	"LM1.2X002",
+	"Samba",
+/*              "NT LM 0.12", */
+/*              "NT LANMAN 1.0", */
+	NULL};
+    SMB_Handle_Type con;
+
+    SMB_Init();
+    con = SMB_Connect_Server(NULL, SERVER, DOMAIN);
+    if (con == NULL) {		/* Error ... */
+	con = SMB_Connect_Server(NULL, BACKUP, DOMAIN);
+	if (con == NULL) {
+	    return (NULL);
+	}
+    }
+    if (SMB_Negotiate(con, SMB_Prots) < 0) {	/* An error */
+	SMB_Discon(con, 0);
+	return (NULL);
+    }
+    /* Test for a server in share level mode do not authenticate against it */
+    if (con->Security == 0) {
+	SMB_Discon(con, 0);
+	return (NULL);
+    }
+    memcpy(nonce, con->Encrypt_Key, 8);
+
+    return (con);
+}
+
+int
+NTLM_Auth(void *handle, char *USERNAME, char *PASSWORD, int flag)
+{
+    SMB_Handle_Type con = handle;
+
+    if (SMB_Logon_Server(con, USERNAME, PASSWORD, NULL, flag) < 0) {
+	return (NTV_LOGON_ERROR);
+    }
+    return (NTV_NO_ERROR);
+}
+
+void
+NTLM_Disconnect(void *handle)
+{
+    SMB_Handle_Type con = handle;
+    SMB_Discon(con, 0);
+}
Index: squid/src/auth/ntlm/helpers/SMB/smbval/valid.h
diff -u /dev/null squid/src/auth/ntlm/helpers/SMB/smbval/valid.h:1.2.10.1
--- /dev/null	Mon Jan 26 04:57:41 2004
+++ squid/src/auth/ntlm/helpers/SMB/smbval/valid.h	Tue Sep  3 10:42:42 2002
@@ -0,0 +1,15 @@
+#ifndef _VALID_H_
+#define _VALID_H_
+/* SMB User verification function */
+
+#define NTV_NO_ERROR 0
+#define NTV_SERVER_ERROR 1
+#define NTV_PROTOCOL_ERROR 2
+#define NTV_LOGON_ERROR 3
+
+int Valid_User(char *USERNAME, char *PASSWORD, char *SERVER, char *BACKUP, char *DOMAIN);
+void *NTLM_Connect(char *SERVER, char *BACKUP, char *DOMAIN, char *nonce);
+int NTLM_Auth(void *handle, char *USERNAME, char *PASSWORD, int flag);
+void NTLM_Disconnect(void *handle);
+
+#endif
Index: squid/src/auth/ntlm/helpers/winbind/Makefile.am
diff -u /dev/null squid/src/auth/ntlm/helpers/winbind/Makefile.am:1.5.10.1
--- /dev/null	Mon Jan 26 04:57:41 2004
+++ squid/src/auth/ntlm/helpers/winbind/Makefile.am	Tue Sep  3 10:42:43 2002
@@ -0,0 +1,11 @@
+#
+#  Makefile for the Squid Object Cache server
+#
+#  $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+#
+
+libexec_PROGRAMS = wb_ntlmauth
+wb_ntlmauth_SOURCES = wb_ntlm_auth.c wb_common.c
+INCLUDES = -I. -I$(top_builddir)/include -I$(top_srcdir)/include \
+    -I$(top_srcdir)/src
+LDADD = -L$(top_builddir)/lib -lmiscutil -lntlmauth -lm
Index: squid/src/auth/ntlm/helpers/winbind/samba_nss.h
diff -u /dev/null squid/src/auth/ntlm/helpers/winbind/samba_nss.h:1.3.10.1
--- /dev/null	Mon Jan 26 04:57:41 2004
+++ squid/src/auth/ntlm/helpers/winbind/samba_nss.h	Tue Sep  3 10:42:43 2002
@@ -0,0 +1,105 @@
+#ifndef _NSSWITCH_NSS_H
+#define _NSSWITCH_NSS_H
+/* 
+   Unix SMB/Netbios implementation.
+   Version 2.0
+
+   a common place to work out how to define NSS_STATUS on various
+   platforms
+
+   Copyright (C) Tim Potter 2000
+   
+   This library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Library General Public
+   License as published by the Free Software Foundation; either
+   version 2 of the License, or (at your option) any later version.
+   
+   This library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Library General Public License for more details.
+   
+   You should have received a copy of the GNU Library General Public
+   License along with this library; if not, write to the
+   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+   Boston, MA  02111-1307, USA.   
+*/
+
+#ifdef HAVE_NSS_COMMON_H
+
+/* Sun Solaris */
+
+#include <nss_common.h>
+#include <nss_dbdefs.h>
+#include <nsswitch.h>
+
+typedef nss_status_t NSS_STATUS;
+
+#define NSS_STATUS_SUCCESS     NSS_SUCCESS
+#define NSS_STATUS_NOTFOUND    NSS_NOTFOUND
+#define NSS_STATUS_UNAVAIL     NSS_UNAVAIL
+#define NSS_STATUS_TRYAGAIN    NSS_TRYAGAIN
+
+#elif HAVE_NSS_H
+
+/* GNU */
+
+#include <nss.h>
+
+typedef enum nss_status NSS_STATUS;
+
+#elif HAVE_NS_API_H
+
+/* SGI IRIX */
+
+/* following required to prevent warnings of double definition
+ * of datum from ns_api.h
+*/
+#ifdef DATUM
+#define _DATUM_DEFINED
+#endif
+
+#include <ns_api.h>
+
+typedef enum
+{
+  NSS_STATUS_SUCCESS=NS_SUCCESS,
+  NSS_STATUS_NOTFOUND=NS_NOTFOUND,
+  NSS_STATUS_UNAVAIL=NS_UNAVAIL,
+  NSS_STATUS_TRYAGAIN=NS_TRYAGAIN
+} NSS_STATUS;
+
+#define NSD_MEM_STATIC 0
+#define NSD_MEM_VOLATILE 1
+#define NSD_MEM_DYNAMIC 2
+
+#elif defined(HPUX)
+/* HP-UX 11 */
+
+#include "nsswitch/hp_nss_common.h"
+#include "nsswitch/hp_nss_dbdefs.h"
+#include <nsswitch.h>
+
+#ifndef _HAVE_TYPEDEF_NSS_STATUS
+#define _HAVE_TYPEDEF_NSS_STATUS
+typedef nss_status_t NSS_STATUS;
+
+#define NSS_STATUS_SUCCESS     NSS_SUCCESS
+#define NSS_STATUS_NOTFOUND    NSS_NOTFOUND
+#define NSS_STATUS_UNAVAIL     NSS_UNAVAIL
+#define NSS_STATUS_TRYAGAIN    NSS_TRYAGAIN
+#endif /* HPUX */
+
+#else /* Nothing's defined. Neither gnu nor sun nor hp */
+
+typedef enum
+{
+  NSS_STATUS_SUCCESS=0,
+  NSS_STATUS_NOTFOUND=1,
+  NSS_STATUS_UNAVAIL=2,
+  NSS_STATUS_TRYAGAIN=3
+} NSS_STATUS;
+
+#endif
+
+#endif /* _NSSWITCH_NSS_H */
